# Seald SDK

> ⚠️ This package is deprecated : you can use [`@seald-io/sdk`](https://www.npmjs.com/package/@seald-io/sdk) instead.

SealdSDK allows you to use the full power of Seald encryption, directly in your application, whether a web-application
in the browser, a Node.js server, a react-native mobile app, ...

You can create and retrieve Seald identities for your app's users, encrypt and decrypt files, create encryption
sessions, add or revoke recipients ...

The Seald SDK has plugins you may be interested in:
- [`@seald-io/sdk-plugin-ssks-2mr`](https://www.npmjs.com/package/@seald-io/sdk-plugin-ssks-2mr)
- [`@seald-io/sdk-plugin-ssks-password`](https://www.npmjs.com/package/@seald-io/sdk-plugin-ssks-password)


## Installing the Seald SDK

First, install the Seald SDK:
```sh
yarn add @seald-io/sdk-react-native
```

Seald SDK uses five other native modules that must be included.
```sh
yarn add @react-native-async-storage/async-storage @seald-io/react-native-scrypt react-native-quick-crypto react-native-quick-base64 @craftzdog/react-native-buffer
```

The use of `react-native-quick-crypto` and our SDK makes it necessary to define a specific `Buffer` polyfill in global.
As early as possible in your application, add the following lines:
```js
import { Buffer } from '@craftzdog/react-native-buffer'
global.Buffer = Buffer
```

## Usage

```js
import SDK from '@seald-io/sdk-react-native'
```


And use the SDK as usual.

For more information, visit our website : https://seald.io

For the full documentation, visit our documentation page : https://docs.seald.io/en/sdk/

© 2024 Seald SAS

You can find the license information of Open Source libraries used in Seald SDK for JavaScript at <https://download.seald.io/download/js_dependencies_licenses.txt>.
