"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EncryptionSessionRetrievalFlow = void 0;
/* global fetch */
require("./patches");
const utils_1 = require("./utils");
const async_storage_1 = __importDefault(require("@react-native-async-storage/async-storage"));
// Seald SDK
require("@seald-io/sdk/lib/declarations");
const main_js_1 = require("@seald-io/sdk/lib/main.js");
const sscryptoNode = __importStar(require("sscrypto/node"));
const rsaUtils = __importStar(require("sscrypto/utils/rsaUtils"));
const crypto = __importStar(require("crypto"));
// SDK local database
const nedbclient_1 = __importDefault(require("follicle/build/lib/clients/nedbclient"));
const createNeDbClient = (databasePath, serializationHooks) => nedbclient_1.default.connect(databasePath || 'nedb://memory', serializationHooks);
const readKeyBackup = async (databasePath) => {
    if (databasePath) {
        const keyBackup = await async_storage_1.default.getItem(`${databasePath}/SealdKeyBackup`);
        return keyBackup ? Buffer.from(keyBackup, 'base64') : null;
    }
    return null;
};
const writeKeyBackup = async (databasePath, encryptedKeyBackup) => {
    if (databasePath) {
        if (encryptedKeyBackup)
            await async_storage_1.default.setItem(`${databasePath}/SealdKeyBackup`, encryptedKeyBackup.toString('base64'));
        else
            await async_storage_1.default.removeItem(`${databasePath}/SealdKeyBackup`);
    }
};
exports.default = ({ apiURL, hairlessURL, appId, nedbClient, sscrypto, getRSAKeyPromise, scrypt, databasePath, databaseKey, databaseRawKey, shouldWaterfallApi, plugins, keySize, createEncryptionSessionCache, encryptionSessionCacheTTL, encryptionSessionCacheCleanupInterval }) => {
    // We're supposing that react-native-quick-crypto is installed in the RN environment.
    // RNQC cannot generate pkcs1, or any type of unencrypted key. pkcs8 without password works, and we convert it to pkcs1/der after that.
    const getRSAKeyFromQuickCrypto = (keySize = 4096) => new Promise((resolve, reject) => {
        if (![1024, 2048, 4096].includes(keySize)) {
            reject(new Error('Invalid key size. Must be one of [1024, 2048, 4096]'));
            return;
        }
        crypto.generateKeyPair('rsa', {
            modulusLength: keySize,
            publicKeyEncoding: { type: 'spki', format: 'pem' },
            privateKeyEncoding: { type: 'pkcs8', format: 'pem' }
        }, (err, publicKey, privateKey) => {
            if (err) {
                return reject(err);
            }
            try {
                const pkcs1Key = rsaUtils.unwrapPrivateKey(rsaUtils.convertPEMToDER(privateKey, 'PRIVATE KEY'));
                resolve(pkcs1Key.toString('base64'));
            }
            catch (error) {
                reject(error);
            }
        });
    });
    return (0, main_js_1.SDK)({
        platform: 'react-native',
        fetch,
        sscrypto: sscrypto || sscryptoNode,
        getRSAKeyPromise: getRSAKeyPromise || getRSAKeyFromQuickCrypto,
        scrypt: scrypt || utils_1.scrypt,
        nedbClient,
        createNeDbClient,
        databasePath,
        databaseKey,
        databaseRawKey,
        apiURL,
        hairlessURL,
        appId,
        shouldWaterfallApi,
        plugins,
        keySize,
        createEncryptionSessionCache,
        encryptionSessionCacheTTL,
        encryptionSessionCacheCleanupInterval,
        readKeyBackup,
        writeKeyBackup
    });
};
// SDK Enums
var main_1 = require("@seald-io/sdk/lib/main");
Object.defineProperty(exports, "EncryptionSessionRetrievalFlow", { enumerable: true, get: function () { return main_1.EncryptionSessionRetrievalFlow; } });
//# sourceMappingURL=seald-sdk-react-native.js.map